/*  
    AVFS: A Virtual File System Library
    Copyright (C) 1998  Miklos Szeredi (mszeredi@inf.bme.hu)
    
    This file can be distributed either under the GNU LGPL, or under
    the GNU GPL. See the file COPYING.LIB and COPYING. 
*/

#include <sys/types.h>

extern int      __av_virtopen       (const char *path, int flags, int mode);
extern int      __av_virtopen64     (const char *path, int flags, int mode);
extern int      __av_virtcreat      (const char *path, mode_t mode);
extern int      __av_virtcreat64    (const char *path, mode_t mode);
extern int      __av_virtclose      (int fh);
extern ssize_t  __av_virtread       (int fh, void *buf, size_t nbyte);
extern ssize_t  __av_virtwrite      (int fh, const void *buf, size_t nbyte);
extern off_t    __av_virtlseek      (int fh, off_t offset, int whence);
extern int      __av_virtfstat      (int fh, void *buf);
extern int      __av_virtfstat64    (int fh, void *buf);
extern int      __av_virtgetdents   (int fh, void *ent, size_t nbyte);
extern int      __av_virtgetdents64 (int fh, void *ent, size_t nbyte);
extern int      __av_virtstat       (const char *path, void *buf);
extern int      __av_virtstat64     (const char *path, void *buf);
extern int      __av_virtlstat      (const char *path, void *buf);
extern int      __av_virtlstat64    (const char *path, void *buf);
extern int      __av_virtaccess     (const char *path, int amode);
extern int      __av_virtreadlink   (const char *path, void *buf, size_t bsiz);
extern int      __av_virtchdir      (const char *path);
extern int      __av_virtfchdir     (int fh);

extern int      __av_virtlink       (const char *path, const char *newpath);
extern int      __av_virtunlink     (const char *path);
extern int      __av_virtchmod      (const char *path, mode_t mode);
extern int      __av_virtchown      (const char *path, uid_t owner, gid_t grp);
extern int      __av_virtlchown     (const char *path, uid_t owner, gid_t grp);
extern int      __av_virtrmdir      (const char *path);
extern int      __av_virtmkdir      (const char *path, mode_t mode);
extern int      __av_virtmknod      (const char *path, mode_t mode, dev_t dev);
extern int      __av_virtsymlink    (const char *path, const char *newpath);
extern int      __av_virtrename     (const char *path, const char *newpath);
extern int      __av_virtutime      (const char *path, void *buf);
extern int      __av_virtutimes     (const char *path, void *buf);

extern int      __av_virtfchmod     (int fh, mode_t mode);
extern int      __av_virtfchown     (int fh, uid_t owner, gid_t grp);

extern int      __av_virtexecve     (const char *filename, 
				     char *const *argv, 
				     char *const *envp);

extern void    *__av_virtmmap       (void *start, size_t len, int prot,
				     int flags, int fd, off_t offset);
extern int      __av_virtacl        (const char *path, 
				     int cmd, int nent, void *aclbuf);
	
extern void          *__av_virtopendir  (const char *path);
extern int            __av_virtclosedir (void *dirp);
extern void          *__av_virtreaddir  (void *dirp);
extern off_t          __av_virttelldir  (void *dirp);
extern void           __av_virtseekdir  (void *dirp, off_t loc);
extern void           __av_virtrewinddir(void *dirp);

#ifdef HAVE_OPEN64
extern offset_t __av_virtlseek64     (int fh, offset_t offset, int whence);
extern void    *__av_virtmmap64      (void *start, size_t len, int prot,
				      int flags, int fd, offset_t offset);
#endif
